#!/usr/local/bin/perl

# cache2edge.perl
# canonicalize cache summary data to edge format:
# lines of quoted name/value pairs separated by commas, all enclosed in parens
# i.e.
# ( "srchost=uc.cache.nlanr.net", "srcip=141.142.121.5", .... )
# 5/96
# tamara munzner

$ip{"sd"} = "198.17.46.58";
$ip{"sv"} = "192.203.230.19";
$ip{"bo"} = "192.52.106.30";
$ip{"uc"} = "141.142.121.5";
$ip{"pb"} = "128.182.72.190";
$ip{"it"} = "132.236.77.25";
$ip{"dc"} = "192.101.98.5";

$key = $ARGV[0];
$max = $ARGV[1] if $ARGV[1];
$go = -1;

open(JUNK, ">>junk.res");

while (<STDIN>){
    chop;
    @line = split(' ');
#print "### ", join('%',@line), "%\n";
    if ($go >= 0 && $line[0] =~ /^------------*$/) {
#	$go = ($go == 2) ? -1 : $go++;
	$go++;
	$go = -1 if $go > 2;
    } elsif ($go < 0 && $line[0] eq "SUMMARY" && $line[2] eq "CLIENT") {
	$go = 0;
    } elsif ($go > 0) {
	$dst = "\L@line[0]\E";
	if (index($dst, '.') < 0) {
	    $dst = "\L$dst\E" . ".cache.nlanr.net";
	} elsif (substr($dst,0,1) eq '[') {
	    ($junk, $dst) = split('\[', $dst);
	    ($dst, $junk) = split('\]', $dst);
	    print JUNK "no name for $dst\n";
	} else {
	    $dst = join('.',reverse(split('\.',$dst)));
	}
	$total = @line[4];
	$percent = $max ? 100*$total/$max : @line[5];
	$dstmode = ($dst =~ /[a-z]|[A-Z]/) ? "dsthost" : "dstip";
	printf "( \"srchost=%s\", \"srcip=%s\", \"$dstmode=%s\", \"traffic_count=%.2f\", \"traffic_percent=%.0f\" )\n", 
	    $key . ".cache.nlanr.net", $ip{$key}, $dst, $total, $percent
		if ($total > 0.0);
    }
}

close(JUNK);
