#!/usr/sbin/perl

########################################################################
# linegrouper.perl
# create group tags based on regexp input
#  specifically for groups based on multiple tag values. 
#  can only have one set of arguments per invocation.
#   (see also grouper.perl which groups based on value of a single tag)
#   
# input: NDP format (lines of name/value pairs on stdin)
#         "tag=value" "name=<regexp>" "name2=<regexp2>" ... "namek=<regexpk>"
# output: NDP format, adding "tag=value" pair for lines where 
#          ALL name/regexp values match
#
# usage:can create groups, colorize based on multitag criteria. 
#
# tamara munzner
# 6/96
########################################################################

$i = 0;

# the shell strips the doublequotes for us
($tag,$value) = split('=', shift(@ARGV));
while (@ARGV) {
    undef($name, $regexp);
    ($name,$regexp) = split('=', shift(@ARGV));
    $comps[$i] = substr($regexp,0,1);
    $regexp = substr($regexp,1);
    $namedef{$name} = 1;
    $names[$i] = $name;
    $regexps[$i] = $regexp;
    $i++;
}


# need to strip the quotes off for a match
while (<STDIN>) {
    # deal with a series of items that look like this:
    # ( "name=val", "name2=val2", ...)
    next if $_ eq "\n";
    undef(@gotit);
    chop;
    @line = eval($_);
    print "(";
    foreach $item (@line) {
	undef($lhs, $rhs);
	print " \"$item\",";
	($lhs,$rhs) = split('=', $item);
	if (defined($namedef{$lhs})) {
	    foreach $j (0..$i-1) {
		$tmprhs = $rhs;
		$gotit[$j] = 1 if (($names[$j] eq $lhs) && 
				   ($comps[$j] eq "~") && ($tmprhs =~ /$regexps[$j]/));
		$tmprhs = $rhs;
		$gotit[$j] = 1 if (($names[$j] eq $lhs) && 
				   ($comps[$j] eq "!") && ($tmprhs !~ /$regexps[$j]/));
	    }
	}
    }
    $go = 1;
    foreach $j (0..$i-1) {
	if ($gotit[$j] != 1) {
	    $go = 0;
	    last;
	}
    }
    print " \"$tag=$value\" " if $go;
    print ")\n";
}
	
