#!/usr/sbin/perl

# tunnel2edge.perl
# canonicalize mbone tunnels to edge format:
# lines of quoted name/value pairs separated by commas, all enclosed in parens
# i.e.
# ( "srchost=uc.cache.nlanr.net", "srcip=141.142.121.5", .... )
# that is, mbone tunnels in the "map -l" format
#  available from "telnet mwatch.cl.cam.ac.uk 6666" or
#  http://www.cl.cam.ac.uk:80/mbone
# 5/96
# tamara munzner

while (<STDIN>) {
    chop;
    ($type, $src, $dst, $info) = split;
    if ($type eq ">" && $info && $info !~ /disabled/ && $info !~ /down/ && 
#    if ($type eq ">" && $info && $info !~ /disabled/ &&
	$dst !~ /INADDR_ANY/ && $dst !~ /DVMRP.*\.MCAST\.NET/) {
	($srchost, $srcip) = split('\(', $src);
	($dsthost, $dstip) = split('\(', $dst);
	chop $srcip; # trailing ')'
	chop $dstip;
	$info = substr($info,1);
	chop $info;
	$str = "(";
	$str .= " \"srchost=$srchost\"," if $srchost =~ /[a-z]|[A-Z]/;
	$str .= " \"dsthost=$dsthost\"," if $dsthost =~ /[a-z]|[A-Z]/;
	$str .= " \"srcip=$srcip\", \"dstip=$dstip\",";
	$str .= " \"info=$info\"";
	$str .= ")\n";
	printf $str if $dstip =~ /[0-9]/; # don't print out when line is blank
    }
}
